/*
--------------------------------------------------------------------------------
Examplefile to show usage of LawnMaker 1.2

This is a very simple example that works with blunt grassblades to create a
patch of english lawn (everything cut exactly to the same height.
--------------------------------------------------------------------------------
*/

//+w640 +h450 +a0.3 +am2 +bm2 +bs8 +wt6

#version 3.8;

#include "lawnmaker.inc"

global_settings {
  assumed_gamma 1.0
  max_trace_level 5
  radiosity {
    pretrace_start 0.08
    pretrace_end   0.04
    count 50, 1000
    nearest_count 10, 5
    error_bound 1
    recursion_limit 2
    low_error_factor .3
    gray_threshold 0.0
    minimum_reuse 0.015
    maximum_reuse 0.1
    brightness 1

    adc_bailout 0.01/2
    normal off
    media off
    always_sample off
    //max_sample 1.0
  }
}

sphere {0, 1e4 pigment {rgb 0.5} finish {emission 1.0 diffuse 0.0}}

plane {y, 0.0 pigment {rgb 0.5}}

camera { 
  location  <0, 5, -7> 
  direction 1.5*z
  right     x*image_width/image_height
  angle     40
  look_at   <0.0, 0.0, 0.0>
}

light_source {
  <-30, 30, -30>            
  color rgb <0.98, 0.98, 0.97>*3 
}

light_source {
  <30, 30, 30>            
  color rgb <1, 1, 1>*0.1 
  shadowless
}

//======================================================================================
// Only the necessary values are changed
#declare LawnStart = <-2, -2>;
#declare LawnStop  = < 2,  2>;
#declare LawnStepX = <0.03, 0.03>;
#declare LawnStepZ = <0.03, 0.03>;

#declare LawnHeight = pigment { rgb 1 }


//to save space below:
#declare h = <0.2,0.2,0.5>;

#declare T = 3;
#declare TypeGeometry = array[T] { Blunt3,     Blunt2,      Blunt1     }
#declare TypeWeight   = array[T] { 1,          1,           1          }
#declare TypeSize1    = array[T] { h,          h,           h          }
#declare TypeSize2    = array[T] { h,          h,           h          }
#declare TypeColMap   = array[T] { 0,          0,           0          }
#declare TypeTurn     = array[T] { <0, 360>,   <0, 360>,    <0, 360>   }
#declare TypeIncline  = array[T] { <0, 10>,    <0, 10>,     <0, 10>    }

// invoking LawnMaker and thus actually producing the grass
LawnMaker()
GrassPatch

